from rauth import OAuth2Service
import json

class ExampleOAuth2Client:
    def __init__(self, client_id, client_secret, url="https://auth.brightspace.com/core/connect/token"):
        self.access_token = None

        self.service = OAuth2Service(
            name="testdtuToken",
            client_id=client_id,
            client_secret=client_secret,
            access_token_url="https://auth.brightspace.com/core/connect/token",
            authorize_url="https://auth.brightspace.com/oauth2/auth", # "http://api.example.com/oauth/access_token",
            base_url="http://auth.brightspace.com/",

        )

        redirect_uri = 'https://localhost:3434/redirecturi'
        params = {'scope': 'core:*:*',
                  'response_type': 'code',
                  'redirect_uri': redirect_uri,
                  'state': 'good'}

        url = self.service.get_authorize_url(**params)
        print(url)

        session = self.service.get_auth_session(data={'redirect_uri': redirect_uri, 'grant_type': 'authorization_code', 'code': 'good'}, decoder=json.loads)

        self.get_access_token()

    def get_access_token(self):
        data = {'code': 'bar',  # specific to my app
                'grant_type': 'client_credentials', # generally required!
               }

        session = self.service.get_auth_session(data=data, decoder=json.loads)

        self.access_token = session.access_token

if __name__ == "__main__":
    from unlearn.learn_config import LearnConfig, start_localhost
    url = "https://auth.brightspace.com/core/connect/token"
    # refresh_token = cc['refresh_token']
    # refresh_token = "rt.eu-west-1.SAmtMKD3oe094NV6Yc4F8UuROyRdHMJRz_XwpiYtwfI"
    client_id = "4801a477-11c7-4cfc-8732-736f041578be"
    client_secret = "niLXYwe9f_pQe2RzvZ8LtYE6Ls6DSiZ_0IeTCPhx4_8"
    # payload = f'grant_type=refresh_token&refresh_token={refresh_token}&client_id={self.client_id}&client_secret={self.client_secret}&scope=core%3A*%3A*'
    # headers = {
    #     'Content-Type': 'application/x-www-form-urlencoded'
    # }

    # response = requests.request("POST", url, headers=headers, data=payload)

    # lc = LearnConfig()
    start_localhost()

    ec = ExampleOAuth2Client(client_id, client_secret)
    a = 234


    pass