# file: flow_managers.py



from rauth import OAuth2Service
import json

class ExampleOAuth2Client:
    def __init__(self, client_id, client_secret, url="https://auth.brightspace.com/core/connect/token"):
        self.access_token = None

        self.service = OAuth2Service(
            name="testdtuToken",
            client_id=client_id,
            client_secret=client_secret,
            access_token_url="https://auth.brightspace.com/core/connect/token",
            authorize_url="https://auth.brightspace.com/oauth2/auth", # "http://api.example.com/oauth/access_token",
            base_url="http://auth.brightspace.com/",

        )

        redirect_uri = 'https://localhost:3434/redirecturi'
        params = {'scope': 'core:*:*',
                  'response_type': 'code',
                  'redirect_uri': redirect_uri,
                  'state': 'good'}

        url = self.service.get_authorize_url(**params)
        print(url)

        session = self.service.get_auth_session(data={'redirect_uri': redirect_uri, 'grant_type': 'authorization_code', 'code': 'good'}, decoder=json.loads)

        self.get_access_token()

    def get_access_token(self):
        data = {'code': 'bar',  # specific to my app
                'grant_type': 'client_credentials', # generally required!
               }

        session = self.service.get_auth_session(data=data, decoder=json.loads)

        self.access_token = session.access_token

# from fastapi import FastAPI
# from fastapi.responses import HTMLResponse

# from .flow_managers import se_flow_manager

# app = FastAPI()
#
# @app.get('/stuff')
# def get_providers():
#     state = "42"
#     se_auth_url = se_flow_manager.get_authorization_endpoint(state)
#     html_content = f"""
#      <html>
#          <head>
#              <title>Connect your account</title>
#          </head>
#          <body>
#              <p>Please select any of the links below to connect your account to the provider</p>
#              <p><a href="{se_auth_url}" target="_blank">Connect to Stack Exchange</a></p>
#          </body>
#      </html>
#      """
#     return HTMLResponse(html_content)

if __name__ == "__main__":
    from unlearn.learn_config import LearnConfig, start_localhost, S
    url = "https://auth.brightspace.com/core/connect/token"
    # refresh_token = cc['refresh_token']
    # refresh_token = "rt.eu-west-1.SAmtMKD3oe094NV6Yc4F8UuROyRdHMJRz_XwpiYtwfI"
    client_id = "4801a477-11c7-4cfc-8732-736f041578be"
    client_secret = "niLXYwe9f_pQe2RzvZ8LtYE6Ls6DSiZ_0IeTCPhx4_8"
    # payload = f'grant_type=refresh_token&refresh_token={refresh_token}&client_id={self.client_id}&client_secret={self.client_secret}&scope=core%3A*%3A*'
    # headers = {
    #     'Content-Type': 'application/x-www-form-urlencoded'
    # }

    # response = requests.request("POST", url, headers=headers, data=payload)

    # lc = LearnConfig()
    access_token_url = "https://auth.brightspace.com/core/connect/token"
    authorize_url = "https://auth.brightspace.com/oauth2/auth"  # "http://api.example.com/oauth/access_token",
    base_url = "https://auth.brightspace.com"
    redirect_uri = 'https://localhost:3434/redirecturi'
    from auth_code_flow import FlowManager
    """
    https://auth.brightspace.com/oauth2/auth?response_type=code&client_id=4801a477-11c7-4cfc-8732-736f041578be&scope=core%3A*%3A*&redirect_uri=https%3A%2F%2Flocalhost%3A3434%2Fredirecturi
     http://auth.brightspace.com/oauth2/auth?client_id=4801a477-11c7-4cfc-8732-736f041578be&redirect_uri=https%3A%2F%2Flocalhost%3A3434%2Fredirecturi&response_type=code&scope=core%3A%2A%3A%2A&state=my_state
    
    """
    se_flow_manager = FlowManager(
        base_uri=base_url,
        client_id=client_id,
        client_secret=client_secret, # "your client secret",  # please read this from env vars for security
        redirect_uri=redirect_uri,
        scope="core:*:*",
        access_token_path="/core/connect/token",
        authorization_path="/oauth2/auth",
        response_type='code',
    )
    start_localhost(se_flow_manager)

    state = "my_state"
    se_auth_url = se_flow_manager.get_authorization_endpoint(state)
    print(se_auth_url)



    print("Code obtained from server", S.CODE)
    # lc = LearnConfig(refresh_token=S.CODE)

    code = S.CODE
    resp = se_flow_manager.fetch_access_token(code, state, post_form_data=True)
    resp_json = resp.json()
    access_token = resp_json['access_token']
    refresh_token = resp_json['refresh_token']

    lc = LearnConfig()

    ec = ExampleOAuth2Client(client_id, client_secret)
    a = 234


    pass